<?php

namespace Drupal\config_export_json\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\Request;
use Drupal\Core\Config\ConfigFactory;
use Drupal\Core\TempStore\PrivateTempStoreFactory;
use Drupal\Core\File\FileSystemInterface;
use Drupal\config_export_json\Service\ConfigExportJsonApi;

/**
 * Controller routines for janrain_connect_ui module routes.
 */
class ConfigExportJsonController extends ControllerBase {

  /**
   * Current request.
   *
   * @var \Symfony\Component\HttpFoundation\Request
   */
  protected $request;

  /**
   * The config factory.
   *
   * @var \Drupal\Core\Config\ConfigFactoryInterface
   */
  protected $config;

  /**
   * The tempstore factory.
   *
   * @var \Drupal\Core\TempStore\PrivateTempStoreFactory
   */
  protected $tempStoreFactory;

  /**
   * The file system.
   *
   * @var \Drupal\Core\File\FileSystemInterface
   */
  private $fileSystem;

  /**
   * Config Export to JSON.
   *
   * @var Drupal\config_export_json\Service\ConfigExportJsonApi
   */
  private $configExportJson;

  /**
   * Construct object.
   */
  public function __construct(
    Request $request,
    ConfigFactory $config_factory,
    PrivateTempStoreFactory $temp_store_factory,
    FileSystemInterface $file_system,
    ConfigExportJsonApi $configExportJson
  ) {
    $this->request = $request;
    $this->config = $config_factory->get('janrain_connect.settings');
    $this->tempStoreFactory = $temp_store_factory;
    $this->fileSystem = $file_system;
    $this->configExportJson = $configExportJson;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('request_stack')->getCurrentRequest(),
      $container->get('config.factory'),
      $container->get('tempstore.private'),
      $container->get('file_system'),
      $container->get('config_export_json.api')
    );
  }

  /**
   * Email Verification page to receive and validate email token.
   */
  public function getJson() {

    $json = $this->configExportJson->getJson();

    if (empty($json)) {
      print '{}';
      exit;
    }

    print $json;
    exit;

  }

}
